'''
Created on Jun 27, 2019

@author: shuangyinli
'''

import sys
import operator
import numpy as np
import math
from numpy import Infinity

def computeUCI(topBetaN, corpus,ntopic):
    topn = len(topBetaN[0])
    len_corpus = float(len(corpus))
    
    total_list = []
    topicn = 0
    for topic in topBetaN:
        T_matrix = np.zeros((topn,topn), dtype=np.double)
        word_index = list(topic)
        #count
        T_matrix[:][:] =1 / ntopic
        for doc in corpus:
            for word in word_index:
                if word in doc:
                    T_matrix[word_index.index(word)][word_index.index(word)] += 1
                    for word2 in word_index[(word_index.index(word)+1):]:
                        if word2 in doc and word in doc and word != word2:
                            T_matrix[word_index.index(word)][word_index.index(word2)] += 1
                            
        for word in word_index:
            T_matrix[word_index.index(word)][word_index.index(word)] = float(T_matrix[word_index.index(word)][word_index.index(word)]) / len_corpus
            for w2 in word_index[(word_index.index(word)+1):]:
                indexid = word_index.index(w2)
                T_matrix[word_index.index(word)][indexid] /= len_corpus
        
        total = 0
        for word in word_index:
            for w2 in word_index[(word_index.index(word)+1):]:
                T_matrix[word_index.index(word)][word_index.index(w2)] /= T_matrix[word_index.index(word)][word_index.index(word)] * T_matrix[word_index.index(w2)][word_index.index(w2)]
                    
                if T_matrix[word_index.index(word)][word_index.index(w2)] > 0:
                    total += math.log(T_matrix[word_index.index(word)][word_index.index(w2)])
                
        total_list.append(total)
        topicn += 1
        #print("Begin the topic " + str(topicn))
    
    return total_list
    
def computeUMass(topBetaN, corpus, ntopic):
    topn = len(topBetaN[0])
    
    total_list = []
    topicn = 0
    for topic in topBetaN:
        T_matrix = np.zeros((topn,topn), dtype=np.double)
        T_matrix[:][:] = 1.0 / ntopic
        
        word_index = list(topic)
        for doc in corpus:
            for word in word_index:
                if word in doc:
                    T_matrix[word_index.index(word)][word_index.index(word)] += 1
                    for word2 in word_index:
                        if word2 in doc and word in doc and word != word2:
                            T_matrix[word_index.index(word)][word_index.index(word2)] += 1
        
        total = 0
        for word in word_index:
            for w2 in word_index:
                if word != w2:
                    T_matrix[word_index.index(word)][word_index.index(w2)] = (T_matrix[word_index.index(word)][word_index.index(w2)] +1) / T_matrix[word_index.index(word)][word_index.index(word)]
                    if T_matrix[word_index.index(word)][word_index.index(w2)] > 0:
                        total += math.log(T_matrix[word_index.index(word)][word_index.index(w2)])
                
        total_list.append(total)
        topicn += 1
        #print("Begin the topic " + str(topicn))
    return total_list


def getctmbeta(beta_file):
    topicDis= []
    ntopics = 100
    nterms = 21968
    
    #ntopics = int(input("Please input the number of topics, default is 100: "))
    #nterms = int(input("Please input the len of dictionary, default is 21968: "))
    topic = []
    for line in open(beta_file, "r", encoding = "utf-8"):
        line = line.rstrip().lstrip()
        topic.append(float(line))
    
    #topic = np.array(map(float, open(beta_file, 'r').readlines()))
    
    topic   = np.reshape(topic, [ntopics, nterms])
    
    for t in range(ntopics):
        topicd = {}
        for w in range(nterms):
            topicd.setdefault(w)
            topicd[w] = topic[t][w]
            
        topicDis.append(topicd)

    pass
    return topicDis

def getTopN(topicDis, n):
    topBetaN =[]
    for topic in topicDis:
        temp = sorted(topic.items(), key=operator.itemgetter(1),  reverse=True)[0:n]
        topBetaN.append(temp)
    return topBetaN

def getbeta(beta_file,topn):
    betafile = open(beta_file, "r", encoding = "utf-8")
    topBetaN = []

    for topic in betafile:
        wordlist =[float(m) for m in topic.split()]
        id_list = np.argsort(-np.array(wordlist))[:topn]
        topBetaN.append(id_list)
        
    return topBetaN

def getbiRATMcorpus(corpusf):
    biRATMcorpus = []
    corpusfile = open(corpusf, "r")
    for line in corpusfile:
        linelist = line.rstrip().lstrip().split("@")
        #sennum = linelist[0]
        sentencelist = linelist[1:]
        doc = []
        for sen in sentencelist:
            wordlist = sen.rstrip().lstrip().split()[1:]
            for word in wordlist:
                wid = int(word.rstrip().lstrip().split(":")[0])
                #wcount = word.rstrip().lstrip().split(":")[1]
                if wid not in doc:
                    doc.append(wid)      
        biRATMcorpus.append(doc)
    return biRATMcorpus

def getLDAcorpus(corpusf):
    LDAcorpus = []
    corpusfile = open(corpusf, "r")
    for line in corpusfile:
        linelist = line.rstrip().lstrip().split()
        #wordnum = int(linelist[0])
        wordlist = linelist[1:]
        doc = []
        for word in wordlist:
            wid = int(word.rstrip().lstrip().split(":")[0])
            #wcount = word.rstrip().lstrip().split(":")[1]
            doc.append(wid)
        LDAcorpus.append(doc)

    return LDAcorpus

if __name__ == '__main__':
    if (len(sys.argv) != 5):
        print("usage: python computeTopicCoherence.py <lda | biRATM | ctm> <top n > <topic(beta)> <coded and formated corpus> \n")
        sys.exit(1)
    
    modelname = sys.argv[1]
    topn = int(sys.argv[2])
    
    beta_file = sys.argv[3]
    corpus_file = sys.argv[4]
    
    if modelname == "lda":
        
        print("begin read beta")
        topBetaN = getbeta(beta_file,topn) 
        print("begin read lda corpus")
        corpus = getLDAcorpus(corpus_file)
    if modelname == "biRATM":
        
        print("begin read beta")
        topBetaN = getbeta(beta_file,topn) 
        print("begin read biRATM corpus")
        corpus = getbiRATMcorpus(corpus_file)
    
    if modelname == "ctm":
        
        print("begin read beta")
        topBetaN = getctmbeta(beta_file)
        print("begin read ctm corpus")
        corpus = getLDAcorpus(corpus_file)
        
    print("Done! ")
    
    #topBetaN = getTopN(topicDis, topn)
    ntopic = len(topBetaN)
    
    print("begin computeUCI")
    UCIlist = computeUCI(topBetaN, corpus, ntopic)
    print(UCIlist)
    print("\nUCI everage value is " + str(sum(UCIlist)  / ntopic ))
    print("\n..............\n")
    print("begin computeUMass")
    UMaslist = computeUMass(topBetaN, corpus, ntopic)
    print(UMaslist)
    print("\nUMass everage value is " + str(sum(UMaslist) / ntopic))
    